package pt.uc.dei.crf_ma.clustering;

import java.util.HashMap;

import pt.uc.dei.crf_ma.SequenceLabeller;

public class KCluster {
	private static int nextClusterId = 1;
	private int clusterId;
	private SequenceLabeller crf;
	private HashMap<String, String> instances;
	
	public KCluster() {
		this.clusterId = nextClusterId++;
		this.instances = new HashMap<String, String>();
	}
	
	public KCluster(String id, String instance) {
		this.clusterId = nextClusterId++;
		this.instances = new HashMap<String, String>();
		this.instances.put(id, instance);
	}
	
	public KCluster(HashMap<String, String> instances) {
		this.clusterId = nextClusterId++;
		this.instances = instances;
	}
	
	public KCluster(SequenceLabeller crf, HashMap<String, String> instances) {
		this.clusterId = nextClusterId++;
		this.crf = crf;
		this.instances = instances;
	}

	public int getClusterId() {
		return clusterId;
	}

	public void setClusterId(int clusterId) {
		this.clusterId = clusterId;
	}

	public SequenceLabeller getCrf() {
		return crf;
	}

	public void setCrf(SequenceLabeller crf) {
		this.crf = crf;
	}

	public HashMap<String, String> getInstances() {
		return instances;
	}

	public void setInstances(HashMap<String, String> instances) {
		this.instances = instances;
	}
	
	public void clearInstances() {
		instances.clear();
	}

	public void addInstance(String id, String dataFile) {
		instances.put(id, dataFile);
	}
	
	public int getSize() {
		return this.instances.size();
	}

	@Override
	public String toString() {
		String s = "Cluster" + this.clusterId + "(";
		for (String instance : this.instances.keySet()) {
			s += instance + ",";
		}
		s += ")";
		return s;
	}
	
}
